#ifndef __TIMER_H__
#define __TIMER_H__

#include <sys/time.h>
#include <iostream>
using namespace std;

class Timer
{
  public:
    Timer(void):running(false) {begin.tv_sec = begin.tv_usec = end.tv_sec = end.tv_usec = 0;}

  public:
    void start(void) {running = true;  gettimeofday(&begin, 0);}
    void stop(void)  {running = false; gettimeofday(&end, 0);}
    struct timeval get(void);
    friend ostream operator<<(ostream&, const Timer&);
    long value(void);

  private:
    bool running;
    struct timeval begin;
    struct timeval end;
};

ostream& operator<<(ostream&, Timer&);

#endif
